#include <qtuitools_includes.h>

#include <smoke.h>
#include <qtuitools_smoke.h>

namespace __smokeqtuitools {

static void *cast(void *xptr, Smoke::Index from, Smoke::Index to) {
  switch(from) {
    case 1:   //QAction
      switch(to) {
        case 1: return (void*)(QAction*)xptr;
        default: return xptr;
      }
    case 2:   //QActionGroup
      switch(to) {
        case 2: return (void*)(QActionGroup*)xptr;
        default: return xptr;
      }
    case 3:   //QBool
      switch(to) {
        case 3: return (void*)(QBool*)xptr;
        default: return xptr;
      }
    case 4:   //QChildEvent
      switch(to) {
        case 6: return (void*)(QEvent*)(QChildEvent*)xptr;
        case 4: return (void*)(QChildEvent*)xptr;
        default: return xptr;
      }
    case 5:   //QDir
      switch(to) {
        case 5: return (void*)(QDir*)xptr;
        default: return xptr;
      }
    case 6:   //QEvent
      switch(to) {
        case 6: return (void*)(QEvent*)xptr;
        default: return xptr;
      }
    case 8:   //QIODevice
      switch(to) {
        case 12: return (void*)(QObject*)(QIODevice*)xptr;
        case 8: return (void*)(QIODevice*)xptr;
        default: return xptr;
      }
    case 9:   //QIncompatibleFlag
      switch(to) {
        case 9: return (void*)(QIncompatibleFlag*)xptr;
        default: return xptr;
      }
    case 10:   //QLayout
      switch(to) {
        case 10: return (void*)(QLayout*)xptr;
        default: return xptr;
      }
    case 11:   //QMetaObject
      switch(to) {
        case 11: return (void*)(QMetaObject*)xptr;
        default: return xptr;
      }
    case 12:   //QObject
      switch(to) {
        case 12: return (void*)(QObject*)xptr;
        case 15: return (void*)(QUiLoader*)(QObject*)xptr;
        default: return xptr;
      }
    case 13:   //QRegExp
      switch(to) {
        case 13: return (void*)(QRegExp*)xptr;
        default: return xptr;
      }
    case 14:   //QTimerEvent
      switch(to) {
        case 6: return (void*)(QEvent*)(QTimerEvent*)xptr;
        case 14: return (void*)(QTimerEvent*)xptr;
        default: return xptr;
      }
    case 15:   //QUiLoader
      switch(to) {
        case 12: return (void*)(QObject*)(QUiLoader*)xptr;
        case 15: return (void*)(QUiLoader*)xptr;
        default: return xptr;
      }
    case 16:   //QWidget
      switch(to) {
        case 16: return (void*)(QWidget*)xptr;
        default: return xptr;
      }
    default: return xptr;
  }
}

// Group of Indexes (0 separated) used as super class lists.
// Classes with super classes have an index into this array.
static Smoke::Index inheritanceList[] = {
    0,	// 0: (no super class)
    12, 0,	// 1: QObject
};

// These are the xenum functions for manipulating enum pointers
void xenum_QGlobalSpace(Smoke::EnumOperation, Smoke::Index, void*&, long&);

// Those are the xcall functions defined in each x_*.cpp file, for dispatching method calls
void xcall_QGlobalSpace(Smoke::Index, void*, Smoke::Stack);
void xcall_QUiLoader(Smoke::Index, void*, Smoke::Stack);

// List of all classes
// Name, external, index into inheritanceList, method dispatcher, enum dispatcher, class flags, size
static Smoke::Class classes[] = {
    { 0L, false, 0, 0, 0, 0, 0 },	// 0 (no class)
    { "QAction", true, 0, 0, 0, 0, 0 },	//1
    { "QActionGroup", true, 0, 0, 0, 0, 0 },	//2
    { "QBool", true, 0, 0, 0, 0, 0 },	//3
    { "QChildEvent", true, 0, 0, 0, 0, 0 },	//4
    { "QDir", true, 0, 0, 0, 0, 0 },	//5
    { "QEvent", true, 0, 0, 0, 0, 0 },	//6
    { "QGlobalSpace", false, 0, xcall_QGlobalSpace, xenum_QGlobalSpace, Smoke::cf_namespace, 0 },	//7
    { "QIODevice", true, 0, 0, 0, 0, 0 },	//8
    { "QIncompatibleFlag", true, 0, 0, 0, 0, 0 },	//9
    { "QLayout", true, 0, 0, 0, 0, 0 },	//10
    { "QMetaObject", true, 0, 0, 0, 0, 0 },	//11
    { "QObject", true, 0, 0, 0, 0, 0 },	//12
    { "QRegExp", true, 0, 0, 0, 0, 0 },	//13
    { "QTimerEvent", true, 0, 0, 0, 0, 0 },	//14
    { "QUiLoader", false, 1, xcall_QUiLoader, 0, Smoke::cf_constructor|Smoke::cf_virtual, sizeof(QUiLoader) },	//15
    { "QWidget", true, 0, 0, 0, 0, 0 },	//16
};

// List of all types needed by the methods (arguments and return values)
// Name, class ID if arg is a class, and TypeId
static Smoke::Type types[] = {
    { 0, 0, 0 },	//0 (no type)
    { "QAction*", 1, Smoke::t_class|Smoke::tf_ptr },	//1
    { "QActionGroup*", 2, Smoke::t_class|Smoke::tf_ptr },	//2
    { "QBool", 3, Smoke::t_class|Smoke::tf_stack },	//3
    { "QChildEvent*", 4, Smoke::t_class|Smoke::tf_ptr },	//4
    { "QDir", 5, Smoke::t_class|Smoke::tf_stack },	//5
    { "QEvent*", 6, Smoke::t_class|Smoke::tf_ptr },	//6
    { "QFlags<QtConcurrent::ReduceOptions::enum_type>", 0, Smoke::t_uint|Smoke::tf_stack },	//7
    { "QIODevice*", 8, Smoke::t_class|Smoke::tf_ptr },	//8
    { "QIncompatibleFlag", 9, Smoke::t_class|Smoke::tf_stack },	//9
    { "QLayout*", 10, Smoke::t_class|Smoke::tf_ptr },	//10
    { "QMetaObject::Call", 11, Smoke::t_enum|Smoke::tf_stack },	//11
    { "QObject*", 12, Smoke::t_class|Smoke::tf_ptr },	//12
    { "QRegExp&", 13, Smoke::t_class|Smoke::tf_ref },	//13
    { "QString", 0, Smoke::t_voidp|Smoke::tf_stack },	//14
    { "QStringList", 0, Smoke::t_voidp|Smoke::tf_stack },	//15
    { "QStringList*", 0, Smoke::t_voidp|Smoke::tf_ptr },	//16
    { "QTimerEvent*", 14, Smoke::t_class|Smoke::tf_ptr },	//17
    { "QUiLoader*", 15, Smoke::t_class|Smoke::tf_ptr },	//18
    { "QWidget*", 16, Smoke::t_class|Smoke::tf_ptr },	//19
    { "Qt::AlignmentFlag", 0, Smoke::t_enum|Smoke::tf_stack },	//20
    { "Qt::AnchorAttribute", 0, Smoke::t_enum|Smoke::tf_stack },	//21
    { "Qt::AnchorPoint", 0, Smoke::t_enum|Smoke::tf_stack },	//22
    { "Qt::ApplicationAttribute", 0, Smoke::t_enum|Smoke::tf_stack },	//23
    { "Qt::ArrowType", 0, Smoke::t_enum|Smoke::tf_stack },	//24
    { "Qt::AspectRatioMode", 0, Smoke::t_enum|Smoke::tf_stack },	//25
    { "Qt::Axis", 0, Smoke::t_enum|Smoke::tf_stack },	//26
    { "Qt::BGMode", 0, Smoke::t_enum|Smoke::tf_stack },	//27
    { "Qt::BrushStyle", 0, Smoke::t_enum|Smoke::tf_stack },	//28
    { "Qt::CaseSensitivity", 0, Smoke::t_enum|Smoke::tf_stack },	//29
    { "Qt::CheckState", 0, Smoke::t_enum|Smoke::tf_stack },	//30
    { "Qt::ClipOperation", 0, Smoke::t_enum|Smoke::tf_stack },	//31
    { "Qt::ConnectionType", 0, Smoke::t_enum|Smoke::tf_stack },	//32
    { "Qt::ContextMenuPolicy", 0, Smoke::t_enum|Smoke::tf_stack },	//33
    { "Qt::CoordinateSystem", 0, Smoke::t_enum|Smoke::tf_stack },	//34
    { "Qt::Corner", 0, Smoke::t_enum|Smoke::tf_stack },	//35
    { "Qt::CursorMoveStyle", 0, Smoke::t_enum|Smoke::tf_stack },	//36
    { "Qt::CursorShape", 0, Smoke::t_enum|Smoke::tf_stack },	//37
    { "Qt::DateFormat", 0, Smoke::t_enum|Smoke::tf_stack },	//38
    { "Qt::DayOfWeek", 0, Smoke::t_enum|Smoke::tf_stack },	//39
    { "Qt::DockWidgetArea", 0, Smoke::t_enum|Smoke::tf_stack },	//40
    { "Qt::DockWidgetAreaSizes", 0, Smoke::t_enum|Smoke::tf_stack },	//41
    { "Qt::DropAction", 0, Smoke::t_enum|Smoke::tf_stack },	//42
    { "Qt::EventPriority", 0, Smoke::t_enum|Smoke::tf_stack },	//43
    { "Qt::FillRule", 0, Smoke::t_enum|Smoke::tf_stack },	//44
    { "Qt::FocusPolicy", 0, Smoke::t_enum|Smoke::tf_stack },	//45
    { "Qt::FocusReason", 0, Smoke::t_enum|Smoke::tf_stack },	//46
    { "Qt::GestureFlag", 0, Smoke::t_enum|Smoke::tf_stack },	//47
    { "Qt::GestureState", 0, Smoke::t_enum|Smoke::tf_stack },	//48
    { "Qt::GestureType", 0, Smoke::t_enum|Smoke::tf_stack },	//49
    { "Qt::GlobalColor", 0, Smoke::t_enum|Smoke::tf_stack },	//50
    { "Qt::ImageConversionFlag", 0, Smoke::t_enum|Smoke::tf_stack },	//51
    { "Qt::Initialization", 0, Smoke::t_enum|Smoke::tf_stack },	//52
    { "Qt::InputMethodHint", 0, Smoke::t_enum|Smoke::tf_stack },	//53
    { "Qt::InputMethodQuery", 0, Smoke::t_enum|Smoke::tf_stack },	//54
    { "Qt::ItemDataRole", 0, Smoke::t_enum|Smoke::tf_stack },	//55
    { "Qt::ItemFlag", 0, Smoke::t_enum|Smoke::tf_stack },	//56
    { "Qt::ItemSelectionMode", 0, Smoke::t_enum|Smoke::tf_stack },	//57
    { "Qt::Key", 0, Smoke::t_enum|Smoke::tf_stack },	//58
    { "Qt::KeyboardModifier", 0, Smoke::t_enum|Smoke::tf_stack },	//59
    { "Qt::LayoutDirection", 0, Smoke::t_enum|Smoke::tf_stack },	//60
    { "Qt::MaskMode", 0, Smoke::t_enum|Smoke::tf_stack },	//61
    { "Qt::MatchFlag", 0, Smoke::t_enum|Smoke::tf_stack },	//62
    { "Qt::Modifier", 0, Smoke::t_enum|Smoke::tf_stack },	//63
    { "Qt::MouseButton", 0, Smoke::t_enum|Smoke::tf_stack },	//64
    { "Qt::NavigationMode", 0, Smoke::t_enum|Smoke::tf_stack },	//65
    { "Qt::Orientation", 0, Smoke::t_enum|Smoke::tf_stack },	//66
    { "Qt::PenCapStyle", 0, Smoke::t_enum|Smoke::tf_stack },	//67
    { "Qt::PenJoinStyle", 0, Smoke::t_enum|Smoke::tf_stack },	//68
    { "Qt::PenStyle", 0, Smoke::t_enum|Smoke::tf_stack },	//69
    { "Qt::ScrollBarPolicy", 0, Smoke::t_enum|Smoke::tf_stack },	//70
    { "Qt::ShortcutContext", 0, Smoke::t_enum|Smoke::tf_stack },	//71
    { "Qt::SizeHint", 0, Smoke::t_enum|Smoke::tf_stack },	//72
    { "Qt::SizeMode", 0, Smoke::t_enum|Smoke::tf_stack },	//73
    { "Qt::SortOrder", 0, Smoke::t_enum|Smoke::tf_stack },	//74
    { "Qt::TextElideMode", 0, Smoke::t_enum|Smoke::tf_stack },	//75
    { "Qt::TextFlag", 0, Smoke::t_enum|Smoke::tf_stack },	//76
    { "Qt::TextFormat", 0, Smoke::t_enum|Smoke::tf_stack },	//77
    { "Qt::TextInteractionFlag", 0, Smoke::t_enum|Smoke::tf_stack },	//78
    { "Qt::TileRule", 0, Smoke::t_enum|Smoke::tf_stack },	//79
    { "Qt::TimeSpec", 0, Smoke::t_enum|Smoke::tf_stack },	//80
    { "Qt::ToolBarArea", 0, Smoke::t_enum|Smoke::tf_stack },	//81
    { "Qt::ToolBarAreaSizes", 0, Smoke::t_enum|Smoke::tf_stack },	//82
    { "Qt::ToolButtonStyle", 0, Smoke::t_enum|Smoke::tf_stack },	//83
    { "Qt::TouchPointState", 0, Smoke::t_enum|Smoke::tf_stack },	//84
    { "Qt::TransformationMode", 0, Smoke::t_enum|Smoke::tf_stack },	//85
    { "Qt::UIEffect", 0, Smoke::t_enum|Smoke::tf_stack },	//86
    { "Qt::WidgetAttribute", 0, Smoke::t_enum|Smoke::tf_stack },	//87
    { "Qt::WindowFrameSection", 0, Smoke::t_enum|Smoke::tf_stack },	//88
    { "Qt::WindowModality", 0, Smoke::t_enum|Smoke::tf_stack },	//89
    { "Qt::WindowState", 0, Smoke::t_enum|Smoke::tf_stack },	//90
    { "Qt::WindowType", 0, Smoke::t_enum|Smoke::tf_stack },	//91
    { "QtConcurrent::ReduceOption", 0, Smoke::t_enum|Smoke::tf_stack },	//92
    { "QtConcurrent::ReduceOptions::enum_type", 0, Smoke::t_voidp|Smoke::tf_stack },	//93
    { "QtConcurrent::ThreadFunctionResult", 0, Smoke::t_enum|Smoke::tf_stack },	//94
    { "QtMsgType", 7, Smoke::t_enum|Smoke::tf_stack },	//95
    { "QtValidLicenseForActiveQtModule", 7, Smoke::t_enum|Smoke::tf_stack },	//96
    { "QtValidLicenseForCoreModule", 7, Smoke::t_enum|Smoke::tf_stack },	//97
    { "QtValidLicenseForDBusModule", 7, Smoke::t_enum|Smoke::tf_stack },	//98
    { "QtValidLicenseForDeclarativeModule", 7, Smoke::t_enum|Smoke::tf_stack },	//99
    { "QtValidLicenseForGuiModule", 7, Smoke::t_enum|Smoke::tf_stack },	//100
    { "QtValidLicenseForHelpModule", 7, Smoke::t_enum|Smoke::tf_stack },	//101
    { "QtValidLicenseForMultimediaModule", 7, Smoke::t_enum|Smoke::tf_stack },	//102
    { "QtValidLicenseForNetworkModule", 7, Smoke::t_enum|Smoke::tf_stack },	//103
    { "QtValidLicenseForOpenGLModule", 7, Smoke::t_enum|Smoke::tf_stack },	//104
    { "QtValidLicenseForOpenVGModule", 7, Smoke::t_enum|Smoke::tf_stack },	//105
    { "QtValidLicenseForQt3SupportLightModule", 7, Smoke::t_enum|Smoke::tf_stack },	//106
    { "QtValidLicenseForQt3SupportModule", 7, Smoke::t_enum|Smoke::tf_stack },	//107
    { "QtValidLicenseForScriptModule", 7, Smoke::t_enum|Smoke::tf_stack },	//108
    { "QtValidLicenseForScriptToolsModule", 7, Smoke::t_enum|Smoke::tf_stack },	//109
    { "QtValidLicenseForSqlModule", 7, Smoke::t_enum|Smoke::tf_stack },	//110
    { "QtValidLicenseForSvgModule", 7, Smoke::t_enum|Smoke::tf_stack },	//111
    { "QtValidLicenseForTestModule", 7, Smoke::t_enum|Smoke::tf_stack },	//112
    { "QtValidLicenseForXmlModule", 7, Smoke::t_enum|Smoke::tf_stack },	//113
    { "QtValidLicenseForXmlPatternsModule", 7, Smoke::t_enum|Smoke::tf_stack },	//114
    { "__codecvt_result", 7, Smoke::t_enum|Smoke::tf_stack },	//115
    { "bool", 0, Smoke::t_bool|Smoke::tf_stack },	//116
    { "const QDir&", 5, Smoke::t_class|Smoke::tf_ref|Smoke::tf_const },	//117
    { "const QMetaObject&", 11, Smoke::t_class|Smoke::tf_ref|Smoke::tf_const },	//118
    { "const QMetaObject*", 11, Smoke::t_class|Smoke::tf_ptr|Smoke::tf_const },	//119
    { "const QRegExp&", 13, Smoke::t_class|Smoke::tf_ref|Smoke::tf_const },	//120
    { "const QString&", 0, Smoke::t_voidp|Smoke::tf_ref|Smoke::tf_const },	//121
    { "const QStringList*", 0, Smoke::t_voidp|Smoke::tf_ptr|Smoke::tf_const },	//122
    { "const char*", 0, Smoke::t_voidp|Smoke::tf_ptr|Smoke::tf_const },	//123
    { "const void*", 0, Smoke::t_voidp|Smoke::tf_ptr|Smoke::tf_const },	//124
    { "int", 0, Smoke::t_int|Smoke::tf_stack },	//125
    { "long", 0, Smoke::t_long|Smoke::tf_stack },	//126
    { "std::bidirectional_iterator_tag", 0, Smoke::t_voidp|Smoke::tf_stack },	//127
    { "std::forward_iterator_tag", 0, Smoke::t_voidp|Smoke::tf_stack },	//128
    { "std::random_access_iterator_tag", 0, Smoke::t_voidp|Smoke::tf_stack },	//129
    { "void*", 0, Smoke::t_voidp|Smoke::tf_ptr },	//130
    { "void**", 0, Smoke::t_voidp|Smoke::tf_ptr },	//131
    { "volatile const void*", 0, Smoke::t_voidp|Smoke::tf_ptr|Smoke::tf_const },	//132
};

static Smoke::Index argumentList[] = {
    0,	//0  (void)
    6, 0,	//1  QEvent*
    12, 6, 0,	//3  QObject*, QEvent*
    17, 0,	//6  QTimerEvent*
    4, 0,	//8  QChildEvent*
    123, 0,	//10  const char*
    123, 123, 0,	//12  const char*, const char*
    123, 123, 125, 0,	//15  const char*, const char*, int
    11, 125, 131, 0,	//19  QMetaObject::Call, int, void**
    12, 0,	//23  QObject*
    121, 0,	//25  const QString&
    8, 19, 0,	//27  QIODevice*, QWidget*
    121, 19, 121, 0,	//30  const QString&, QWidget*, const QString&
    121, 12, 121, 0,	//34  const QString&, QObject*, const QString&
    12, 121, 0,	//38  QObject*, const QString&
    117, 0,	//41  const QDir&
    116, 0,	//43  bool
    8, 0,	//45  QIODevice*
    121, 19, 0,	//47  const QString&, QWidget*
    121, 12, 0,	//50  const QString&, QObject*
};

// Raw list of all methods, using munged names
static const char *methodNames[] = {
    "",	//0
    "LicensedActiveQt",	//1
    "LicensedCore",	//2
    "LicensedDBus",	//3
    "LicensedDeclarative",	//4
    "LicensedGui",	//5
    "LicensedHelp",	//6
    "LicensedMultimedia",	//7
    "LicensedNetwork",	//8
    "LicensedOpenGL",	//9
    "LicensedOpenVG",	//10
    "LicensedQt3Support",	//11
    "LicensedQt3SupportLight",	//12
    "LicensedScript",	//13
    "LicensedScriptTools",	//14
    "LicensedSql",	//15
    "LicensedSvg",	//16
    "LicensedTest",	//17
    "LicensedXml",	//18
    "LicensedXmlPatterns",	//19
    "QUiLoader",	//20
    "QUiLoader#",	//21
    "QtCriticalMsg",	//22
    "QtDebugMsg",	//23
    "QtFatalMsg",	//24
    "QtSystemMsg",	//25
    "QtWarningMsg",	//26
    "_ISalnum",	//27
    "_ISalpha",	//28
    "_ISblank",	//29
    "_IScntrl",	//30
    "_ISdigit",	//31
    "_ISgraph",	//32
    "_ISlower",	//33
    "_ISprint",	//34
    "_ISpunct",	//35
    "_ISspace",	//36
    "_ISupper",	//37
    "_ISxdigit",	//38
    "__codecvt_error",	//39
    "__codecvt_noconv",	//40
    "__codecvt_ok",	//41
    "__codecvt_partial",	//42
    "addPluginPath",	//43
    "addPluginPath$",	//44
    "availableLayouts",	//45
    "availableWidgets",	//46
    "childEvent",	//47
    "clearPluginPaths",	//48
    "connectNotify",	//49
    "createAction",	//50
    "createAction#",	//51
    "createAction#$",	//52
    "createActionGroup",	//53
    "createActionGroup#",	//54
    "createActionGroup#$",	//55
    "createLayout",	//56
    "createLayout$",	//57
    "createLayout$#",	//58
    "createLayout$#$",	//59
    "createWidget",	//60
    "createWidget$",	//61
    "createWidget$#",	//62
    "createWidget$#$",	//63
    "customEvent",	//64
    "disconnectNotify",	//65
    "event",	//66
    "eventFilter",	//67
    "isLanguageChangeEnabled",	//68
    "isScriptingEnabled",	//69
    "isTranslationEnabled",	//70
    "load",	//71
    "load#",	//72
    "load##",	//73
    "metaObject",	//74
    "pluginPaths",	//75
    "qt_metacall",	//76
    "qt_metacall$$?",	//77
    "qt_metacast",	//78
    "qt_metacast$",	//79
    "setLanguageChangeEnabled",	//80
    "setLanguageChangeEnabled$",	//81
    "setScriptingEnabled",	//82
    "setScriptingEnabled$",	//83
    "setTranslationEnabled",	//84
    "setTranslationEnabled$",	//85
    "setWorkingDirectory",	//86
    "setWorkingDirectory#",	//87
    "staticMetaObject",	//88
    "timerEvent",	//89
    "tr",	//90
    "tr$",	//91
    "tr$$",	//92
    "tr$$$",	//93
    "trUtf8",	//94
    "trUtf8$",	//95
    "trUtf8$$",	//96
    "trUtf8$$$",	//97
    "workingDirectory",	//98
    "~QUiLoader",	//99
};

// (classId, name (index in methodNames), argumentList index, number of args, method flags, return type (index in types), xcall() index)
static Smoke::Method methods[] = {
    { 0, 0, 0, 0, 0, 0, 0 },	// (no method)
    {7, 37, 0, 0, Smoke::mf_static|Smoke::mf_enum, 126, 1},	//1 QGlobalSpace::_ISupper (enum)
    {7, 33, 0, 0, Smoke::mf_static|Smoke::mf_enum, 126, 2},	//2 QGlobalSpace::_ISlower (enum)
    {7, 28, 0, 0, Smoke::mf_static|Smoke::mf_enum, 126, 3},	//3 QGlobalSpace::_ISalpha (enum)
    {7, 31, 0, 0, Smoke::mf_static|Smoke::mf_enum, 126, 4},	//4 QGlobalSpace::_ISdigit (enum)
    {7, 38, 0, 0, Smoke::mf_static|Smoke::mf_enum, 126, 5},	//5 QGlobalSpace::_ISxdigit (enum)
    {7, 36, 0, 0, Smoke::mf_static|Smoke::mf_enum, 126, 6},	//6 QGlobalSpace::_ISspace (enum)
    {7, 34, 0, 0, Smoke::mf_static|Smoke::mf_enum, 126, 7},	//7 QGlobalSpace::_ISprint (enum)
    {7, 32, 0, 0, Smoke::mf_static|Smoke::mf_enum, 126, 8},	//8 QGlobalSpace::_ISgraph (enum)
    {7, 29, 0, 0, Smoke::mf_static|Smoke::mf_enum, 126, 9},	//9 QGlobalSpace::_ISblank (enum)
    {7, 30, 0, 0, Smoke::mf_static|Smoke::mf_enum, 126, 10},	//10 QGlobalSpace::_IScntrl (enum)
    {7, 35, 0, 0, Smoke::mf_static|Smoke::mf_enum, 126, 11},	//11 QGlobalSpace::_ISpunct (enum)
    {7, 27, 0, 0, Smoke::mf_static|Smoke::mf_enum, 126, 12},	//12 QGlobalSpace::_ISalnum (enum)
    {7, 5, 0, 0, Smoke::mf_static|Smoke::mf_enum, 100, 13},	//13 QGlobalSpace::LicensedGui (enum)
    {7, 18, 0, 0, Smoke::mf_static|Smoke::mf_enum, 113, 14},	//14 QGlobalSpace::LicensedXml (enum)
    {7, 12, 0, 0, Smoke::mf_static|Smoke::mf_enum, 106, 15},	//15 QGlobalSpace::LicensedQt3SupportLight (enum)
    {7, 13, 0, 0, Smoke::mf_static|Smoke::mf_enum, 108, 16},	//16 QGlobalSpace::LicensedScript (enum)
    {7, 10, 0, 0, Smoke::mf_static|Smoke::mf_enum, 105, 17},	//17 QGlobalSpace::LicensedOpenVG (enum)
    {7, 3, 0, 0, Smoke::mf_static|Smoke::mf_enum, 98, 18},	//18 QGlobalSpace::LicensedDBus (enum)
    {7, 17, 0, 0, Smoke::mf_static|Smoke::mf_enum, 112, 19},	//19 QGlobalSpace::LicensedTest (enum)
    {7, 1, 0, 0, Smoke::mf_static|Smoke::mf_enum, 96, 20},	//20 QGlobalSpace::LicensedActiveQt (enum)
    {7, 14, 0, 0, Smoke::mf_static|Smoke::mf_enum, 109, 21},	//21 QGlobalSpace::LicensedScriptTools (enum)
    {7, 16, 0, 0, Smoke::mf_static|Smoke::mf_enum, 111, 22},	//22 QGlobalSpace::LicensedSvg (enum)
    {7, 4, 0, 0, Smoke::mf_static|Smoke::mf_enum, 99, 23},	//23 QGlobalSpace::LicensedDeclarative (enum)
    {7, 15, 0, 0, Smoke::mf_static|Smoke::mf_enum, 110, 24},	//24 QGlobalSpace::LicensedSql (enum)
    {7, 9, 0, 0, Smoke::mf_static|Smoke::mf_enum, 104, 25},	//25 QGlobalSpace::LicensedOpenGL (enum)
    {7, 2, 0, 0, Smoke::mf_static|Smoke::mf_enum, 97, 26},	//26 QGlobalSpace::LicensedCore (enum)
    {7, 23, 0, 0, Smoke::mf_static|Smoke::mf_enum, 95, 27},	//27 QGlobalSpace::QtDebugMsg (enum)
    {7, 26, 0, 0, Smoke::mf_static|Smoke::mf_enum, 95, 28},	//28 QGlobalSpace::QtWarningMsg (enum)
    {7, 22, 0, 0, Smoke::mf_static|Smoke::mf_enum, 95, 29},	//29 QGlobalSpace::QtCriticalMsg (enum)
    {7, 24, 0, 0, Smoke::mf_static|Smoke::mf_enum, 95, 30},	//30 QGlobalSpace::QtFatalMsg (enum)
    {7, 25, 0, 0, Smoke::mf_static|Smoke::mf_enum, 95, 31},	//31 QGlobalSpace::QtSystemMsg (enum)
    {7, 6, 0, 0, Smoke::mf_static|Smoke::mf_enum, 101, 32},	//32 QGlobalSpace::LicensedHelp (enum)
    {7, 7, 0, 0, Smoke::mf_static|Smoke::mf_enum, 102, 33},	//33 QGlobalSpace::LicensedMultimedia (enum)
    {7, 11, 0, 0, Smoke::mf_static|Smoke::mf_enum, 107, 34},	//34 QGlobalSpace::LicensedQt3Support (enum)
    {7, 19, 0, 0, Smoke::mf_static|Smoke::mf_enum, 114, 35},	//35 QGlobalSpace::LicensedXmlPatterns (enum)
    {7, 8, 0, 0, Smoke::mf_static|Smoke::mf_enum, 103, 36},	//36 QGlobalSpace::LicensedNetwork (enum)
    {7, 41, 0, 0, Smoke::mf_static|Smoke::mf_enum, 115, 37},	//37 QGlobalSpace::__codecvt_ok (enum)
    {7, 42, 0, 0, Smoke::mf_static|Smoke::mf_enum, 115, 38},	//38 QGlobalSpace::__codecvt_partial (enum)
    {7, 39, 0, 0, Smoke::mf_static|Smoke::mf_enum, 115, 39},	//39 QGlobalSpace::__codecvt_error (enum)
    {7, 40, 0, 0, Smoke::mf_static|Smoke::mf_enum, 115, 40},	//40 QGlobalSpace::__codecvt_noconv (enum)
    {12, 66, 1, 1, Smoke::mf_virtual, 116, 0},	//41 QObject::event(QEvent*)
    {12, 67, 3, 2, Smoke::mf_virtual, 116, 0},	//42 QObject::eventFilter(QObject*, QEvent*)
    {12, 89, 6, 1, Smoke::mf_protected|Smoke::mf_virtual, 0, 0},	//43 QObject::timerEvent(QTimerEvent*)
    {12, 47, 8, 1, Smoke::mf_protected|Smoke::mf_virtual, 0, 0},	//44 QObject::childEvent(QChildEvent*)
    {12, 64, 1, 1, Smoke::mf_protected|Smoke::mf_virtual, 0, 0},	//45 QObject::customEvent(QEvent*)
    {12, 49, 10, 1, Smoke::mf_protected|Smoke::mf_virtual, 0, 0},	//46 QObject::connectNotify(const char*)
    {12, 65, 10, 1, Smoke::mf_protected|Smoke::mf_virtual, 0, 0},	//47 QObject::disconnectNotify(const char*)
    {15, 74, 0, 0, Smoke::mf_const|Smoke::mf_virtual, 119, 1},	//48 QUiLoader::metaObject() const
    {15, 78, 10, 1, Smoke::mf_virtual, 130, 2},	//49 QUiLoader::qt_metacast(const char*)
    {15, 90, 12, 2, Smoke::mf_static, 14, 3},	//50 QUiLoader::tr(const char*, const char*)
    {15, 94, 12, 2, Smoke::mf_static, 14, 4},	//51 QUiLoader::trUtf8(const char*, const char*)
    {15, 90, 15, 3, Smoke::mf_static, 14, 5},	//52 QUiLoader::tr(const char*, const char*, int)
    {15, 94, 15, 3, Smoke::mf_static, 14, 6},	//53 QUiLoader::trUtf8(const char*, const char*, int)
    {15, 76, 19, 3, Smoke::mf_virtual, 125, 7},	//54 QUiLoader::qt_metacall(QMetaObject::Call, int, void**)
    {15, 20, 23, 1, Smoke::mf_ctor, 18, 8},	//55 QUiLoader::QUiLoader(QObject*)
    {15, 75, 0, 0, Smoke::mf_const, 15, 9},	//56 QUiLoader::pluginPaths() const
    {15, 48, 0, 0, 0, 0, 10},	//57 QUiLoader::clearPluginPaths()
    {15, 43, 25, 1, 0, 0, 11},	//58 QUiLoader::addPluginPath(const QString&)
    {15, 71, 27, 2, 0, 19, 12},	//59 QUiLoader::load(QIODevice*, QWidget*)
    {15, 46, 0, 0, Smoke::mf_const, 15, 13},	//60 QUiLoader::availableWidgets() const
    {15, 45, 0, 0, Smoke::mf_const, 15, 14},	//61 QUiLoader::availableLayouts() const
    {15, 60, 30, 3, Smoke::mf_virtual, 19, 15},	//62 QUiLoader::createWidget(const QString&, QWidget*, const QString&)
    {15, 56, 34, 3, Smoke::mf_virtual, 10, 16},	//63 QUiLoader::createLayout(const QString&, QObject*, const QString&)
    {15, 53, 38, 2, Smoke::mf_virtual, 2, 17},	//64 QUiLoader::createActionGroup(QObject*, const QString&)
    {15, 50, 38, 2, Smoke::mf_virtual, 1, 18},	//65 QUiLoader::createAction(QObject*, const QString&)
    {15, 86, 41, 1, 0, 0, 19},	//66 QUiLoader::setWorkingDirectory(const QDir&)
    {15, 98, 0, 0, Smoke::mf_const, 5, 20},	//67 QUiLoader::workingDirectory() const
    {15, 82, 43, 1, 0, 0, 21},	//68 QUiLoader::setScriptingEnabled(bool)
    {15, 69, 0, 0, Smoke::mf_const, 116, 22},	//69 QUiLoader::isScriptingEnabled() const
    {15, 80, 43, 1, 0, 0, 23},	//70 QUiLoader::setLanguageChangeEnabled(bool)
    {15, 68, 0, 0, Smoke::mf_const, 116, 24},	//71 QUiLoader::isLanguageChangeEnabled() const
    {15, 84, 43, 1, 0, 0, 25},	//72 QUiLoader::setTranslationEnabled(bool)
    {15, 70, 0, 0, Smoke::mf_const, 116, 26},	//73 QUiLoader::isTranslationEnabled() const
    {15, 90, 10, 1, Smoke::mf_static, 14, 27},	//74 QUiLoader::tr(const char*)
    {15, 94, 10, 1, Smoke::mf_static, 14, 28},	//75 QUiLoader::trUtf8(const char*)
    {15, 20, 0, 0, Smoke::mf_ctor, 18, 29},	//76 QUiLoader::QUiLoader()
    {15, 71, 45, 1, 0, 19, 30},	//77 QUiLoader::load(QIODevice*)
    {15, 60, 25, 1, 0, 19, 31},	//78 QUiLoader::createWidget(const QString&)
    {15, 60, 47, 2, 0, 19, 32},	//79 QUiLoader::createWidget(const QString&, QWidget*)
    {15, 56, 25, 1, 0, 10, 33},	//80 QUiLoader::createLayout(const QString&)
    {15, 56, 50, 2, 0, 10, 34},	//81 QUiLoader::createLayout(const QString&, QObject*)
    {15, 53, 0, 0, 0, 2, 35},	//82 QUiLoader::createActionGroup()
    {15, 53, 23, 1, 0, 2, 36},	//83 QUiLoader::createActionGroup(QObject*)
    {15, 50, 0, 0, 0, 1, 37},	//84 QUiLoader::createAction()
    {15, 50, 23, 1, 0, 1, 38},	//85 QUiLoader::createAction(QObject*)
    {15, 88, 0, 0, Smoke::mf_const|Smoke::mf_static|Smoke::mf_attribute, 118, 39},	//86 QUiLoader::staticMetaObject() const
    {15, 99, 0, 0, Smoke::mf_dtor, 0, 40 },	//87 QUiLoader::~QUiLoader()
};

static Smoke::Index ambiguousMethodList[] = {
    0,
};

// Class ID, munged name ID (index into methodNames), method def (see methods) if >0 or number of overloads if <0
static Smoke::MethodMap methodMaps[] = {
    {0, 0, 0},	//0 (no method)
    {7, 1, 20},	// QGlobalSpace::LicensedActiveQt
    {7, 2, 26},	// QGlobalSpace::LicensedCore
    {7, 3, 18},	// QGlobalSpace::LicensedDBus
    {7, 4, 23},	// QGlobalSpace::LicensedDeclarative
    {7, 5, 13},	// QGlobalSpace::LicensedGui
    {7, 6, 32},	// QGlobalSpace::LicensedHelp
    {7, 7, 33},	// QGlobalSpace::LicensedMultimedia
    {7, 8, 36},	// QGlobalSpace::LicensedNetwork
    {7, 9, 25},	// QGlobalSpace::LicensedOpenGL
    {7, 10, 17},	// QGlobalSpace::LicensedOpenVG
    {7, 11, 34},	// QGlobalSpace::LicensedQt3Support
    {7, 12, 15},	// QGlobalSpace::LicensedQt3SupportLight
    {7, 13, 16},	// QGlobalSpace::LicensedScript
    {7, 14, 21},	// QGlobalSpace::LicensedScriptTools
    {7, 15, 24},	// QGlobalSpace::LicensedSql
    {7, 16, 22},	// QGlobalSpace::LicensedSvg
    {7, 17, 19},	// QGlobalSpace::LicensedTest
    {7, 18, 14},	// QGlobalSpace::LicensedXml
    {7, 19, 35},	// QGlobalSpace::LicensedXmlPatterns
    {7, 22, 29},	// QGlobalSpace::QtCriticalMsg
    {7, 23, 27},	// QGlobalSpace::QtDebugMsg
    {7, 24, 30},	// QGlobalSpace::QtFatalMsg
    {7, 25, 31},	// QGlobalSpace::QtSystemMsg
    {7, 26, 28},	// QGlobalSpace::QtWarningMsg
    {7, 27, 12},	// QGlobalSpace::_ISalnum
    {7, 28, 3},	// QGlobalSpace::_ISalpha
    {7, 29, 9},	// QGlobalSpace::_ISblank
    {7, 30, 10},	// QGlobalSpace::_IScntrl
    {7, 31, 4},	// QGlobalSpace::_ISdigit
    {7, 32, 8},	// QGlobalSpace::_ISgraph
    {7, 33, 2},	// QGlobalSpace::_ISlower
    {7, 34, 7},	// QGlobalSpace::_ISprint
    {7, 35, 11},	// QGlobalSpace::_ISpunct
    {7, 36, 6},	// QGlobalSpace::_ISspace
    {7, 37, 1},	// QGlobalSpace::_ISupper
    {7, 38, 5},	// QGlobalSpace::_ISxdigit
    {7, 39, 39},	// QGlobalSpace::__codecvt_error
    {7, 40, 40},	// QGlobalSpace::__codecvt_noconv
    {7, 41, 37},	// QGlobalSpace::__codecvt_ok
    {7, 42, 38},	// QGlobalSpace::__codecvt_partial
    {15, 20, 76},	// QUiLoader::QUiLoader
    {15, 21, 55},	// QUiLoader::QUiLoader#
    {15, 44, 58},	// QUiLoader::addPluginPath$
    {15, 45, 61},	// QUiLoader::availableLayouts
    {15, 46, 60},	// QUiLoader::availableWidgets
    {15, 48, 57},	// QUiLoader::clearPluginPaths
    {15, 50, 84},	// QUiLoader::createAction
    {15, 51, 85},	// QUiLoader::createAction#
    {15, 52, 65},	// QUiLoader::createAction#$
    {15, 53, 82},	// QUiLoader::createActionGroup
    {15, 54, 83},	// QUiLoader::createActionGroup#
    {15, 55, 64},	// QUiLoader::createActionGroup#$
    {15, 57, 80},	// QUiLoader::createLayout$
    {15, 58, 81},	// QUiLoader::createLayout$#
    {15, 59, 63},	// QUiLoader::createLayout$#$
    {15, 61, 78},	// QUiLoader::createWidget$
    {15, 62, 79},	// QUiLoader::createWidget$#
    {15, 63, 62},	// QUiLoader::createWidget$#$
    {15, 68, 71},	// QUiLoader::isLanguageChangeEnabled
    {15, 69, 69},	// QUiLoader::isScriptingEnabled
    {15, 70, 73},	// QUiLoader::isTranslationEnabled
    {15, 72, 77},	// QUiLoader::load#
    {15, 73, 59},	// QUiLoader::load##
    {15, 74, 48},	// QUiLoader::metaObject
    {15, 75, 56},	// QUiLoader::pluginPaths
    {15, 77, 54},	// QUiLoader::qt_metacall$$?
    {15, 79, 49},	// QUiLoader::qt_metacast$
    {15, 81, 70},	// QUiLoader::setLanguageChangeEnabled$
    {15, 83, 68},	// QUiLoader::setScriptingEnabled$
    {15, 85, 72},	// QUiLoader::setTranslationEnabled$
    {15, 87, 66},	// QUiLoader::setWorkingDirectory#
    {15, 88, 86},	// QUiLoader::staticMetaObject
    {15, 91, 74},	// QUiLoader::tr$
    {15, 92, 50},	// QUiLoader::tr$$
    {15, 93, 52},	// QUiLoader::tr$$$
    {15, 95, 75},	// QUiLoader::trUtf8$
    {15, 96, 51},	// QUiLoader::trUtf8$$
    {15, 97, 53},	// QUiLoader::trUtf8$$$
    {15, 98, 67},	// QUiLoader::workingDirectory
    {15, 99, 87},	// QUiLoader::~QUiLoader
};

}

extern "C" {

SMOKE_IMPORT void init_qtcore_Smoke();
SMOKE_IMPORT void init_qtgui_Smoke();

static bool initialized = false;
Smoke *qtuitools_Smoke = 0;

// Create the Smoke instance encapsulating all the above.
void init_qtuitools_Smoke() {
    init_qtcore_Smoke();
    init_qtgui_Smoke();
    if (initialized) return;
    qtuitools_Smoke = new Smoke(
        "qtuitools",
        __smokeqtuitools::classes, 16,
        __smokeqtuitools::methods, 88,
        __smokeqtuitools::methodMaps, 81,
        __smokeqtuitools::methodNames, 99,
        __smokeqtuitools::types, 132,
        __smokeqtuitools::inheritanceList,
        __smokeqtuitools::argumentList,
        __smokeqtuitools::ambiguousMethodList,
        __smokeqtuitools::cast );
    initialized = true;
}

void delete_qtuitools_Smoke() { delete qtuitools_Smoke; }

}
